'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _tymer = require('tymer');

var _tymer2 = _interopRequireDefault(_tymer);

var _mapzen = require('./adapters/mapzen');

var _mapzen2 = _interopRequireDefault(_mapzen);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var dbg = (0, _debug2.default)('app:geocodr');

function retryFailedRequest(err) {
  if (err.status === 504 && err.config && !err.config.__isRetryRequest) {
    err.config.__isRetryRequest = true;
    return (0, _axios2.default)(err.config);
  }
  throw err;
}
_axios2.default.interceptors.response.use(undefined, retryFailedRequest);

exports.default = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(address) {
    var opts = arguments.length <= 1 || arguments[1] === undefined ? _mapzen2.default : arguments[1];
    var params, timer, res, coordinates;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            dbg('address=%o, opts=%o', address, opts);
            params = _extends({}, opts.params, _defineProperty({}, opts.addressParam, address));

            dbg('params=%o', params);
            timer = new _tymer2.default();
            _context.next = 6;
            return _axios2.default.get(opts.url, { params: params });

          case 6:
            res = _context.sent;

            //dbg('geocode: res.data=%s', JSON.stringify(res.data, null, 2))
            coordinates = opts.parse(res.data);

            dbg('geocode: address=%s, coordinates=%o, elapsed=%o', address, coordinates, timer.stop());

            return _context.abrupt('return', coordinates);

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();